	// verilator_coverage annotation
	// generated by verigenSV.pl on Fri Jun  4 15:36:19 2021
	// input file: twe.cfg
	
	// compiler directives
	// /* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	// /* verilator lint_off UNUSED */
	// /* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	`include "./RAS.sv";
	
	module TWE (
 000201		input logic clk,
%000003		input logic res_n,
%000002		input logic lock,
%000003		input logic unlock,
%000028		input logic [KEY_WIDTH-1:0] key,
%000105		input logic [VA48_ADDR_WIDTH-1:0] virt_addr_in,
%000004		input logic virt_addr_in_vld,
%000082		input logic [VA48_PTE_PAGE_BASE_ADDR_WIDTH+VAXX_PTE_PAGE_STATUS_WIDTH-1:0] data_from_memory,
%000008		input logic data_from_memory_vld,
%000001		input logic [VAXX_MODE_WIDTH-1:0] mode,
%000057		input logic [PA48_ADDR_WIDTH-1:0] pte_root_addr,
%000002		output logic locked, 
%000088		output logic [PA48_ADDR_WIDTH-1:0] phys_addr_out, 
%000004		output logic phys_addr_out_vld, 
%000265		output logic [PA48_ADDR_WIDTH-1:0] data_to_memory, 
 000010		output logic data_to_memory_vld, 
%000004		output logic twe_active );
	
	  //
	 // parameter constants 
	//---------------------------
	//----------------------
	// key lock mechanism
	//----------------------
	parameter int KEY_WIDTH = 16;
	parameter logic [KEY_WIDTH-1:0] KEY = 16'hAFFA;
	//----------------------
	// Virtuall addresses
	//----------------------
	parameter int VAXX_MODE_WIDTH = 2;
	parameter int VA48_ADDR_WIDTH = 48;
	parameter int VA48_INDEX_WIDTH = 12;
	//----------------------
	// Page Table Entries
	//----------------------
	parameter int VA48_PTE_ENTRY_WIDTH = 40;
	parameter int VA48_PTE_PAGE_BASE_ADDR_WIDTH = 36;
	parameter int VAXX_PTE_PAGE_STATUS_WIDTH = 4;
	parameter int VA48_PTE_PAGE_OFFSET_WIDTH = 12;
	parameter int VA48_PTE_OFFSET_SIZE = 9;
	parameter int VA48_PTE_LEVEL0_HIGH = 47;
	parameter int VA48_PTE_LEVEL0_LOW = 39;
	parameter int VA48_PTE_LEVEL1_HIGH = 38;
	parameter int VA48_PTE_LEVEL1_LOW = 30;
	parameter int VA48_PTE_LEVEL2_HIGH = 29;
	parameter int VA48_PTE_LEVEL2_LOW = 21;
	parameter int VA48_PTE_LEVEL3_HIGH = 20;
	parameter int VA48_PTE_LEVEL3_LOW = 12;
	//----------------------
	// Physical addresses
	//----------------------
	parameter int PA48_ADDR_WIDTH = 48;
	parameter int PA48_INDEX_WIDTH = 12;
	//----------------------
	// Content Addressable Memory
	//----------------------
	// 48 bit virtual address mode
	//----------------------
	parameter int VA48_CAM_NUM_OF_ENTRIES = 16;
	parameter int VA48_CAM_ENTRY_WIDTH = 72;
	parameter int VA48_CAM_TAG_WIDTH = 36;
	parameter logic [VA48_CAM_ENTRY_WIDTH-1:0] VA48_ZERO_PTE = {VA48_CAM_ENTRY_WIDTH{1'b0}};
	//----------------------
	// ZERO-DATA TO MEMORY
	//----------------------
	parameter logic [PA48_ADDR_WIDTH-1:0] ZERO_DATA_TO_MEMORY = {PA48_ADDR_WIDTH{1'b0}};
	parameter logic [PA48_ADDR_WIDTH-1:0] ZERO_PHYS_ADDR_OUT = {PA48_ADDR_WIDTH{1'b0}};
	parameter logic [VA48_CAM_ENTRY_WIDTH-1:0] ZERO_CAM_ENTRY = {VA48_CAM_ENTRY_WIDTH{1'b0}};
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [2:0] {
		LOCKED = 3'b111,
		IDLE = 3'b000,
		PTE0 = 3'b001,
		PTE1 = 3'b010,
		PTE2 = 3'b011,
		PTE3 = 3'b100,
		WRITE_TLB = 3'b101,
		DONE = 3'b110
	} states_t;
	
	
	// internal state variables
 000025	states_t STATE, NEXT_STATE;
 000037	verilator_coverage: (next point on previous line)

	
	  //
	 // memory instantiations 
	//---------------------------
%000004	uwire VA48_CAM_hit;
	CAM #( VA48_CAM_ENTRY_WIDTH, VA48_CAM_NUM_OF_ENTRIES, VA48_CAM_TAG_WIDTH ) VA48_CAM(
		.clk(clk), .res_n(res_n), 
		.wr(VA48_CAM_wr), .wr_data(VA48_CAM_wr_data[VA48_CAM_ENTRY_WIDTH-1:0]), 
		.rd(VA48_CAM_rd), .rd_data(VA48_CAM_rd_data[VA48_CAM_ENTRY_WIDTH-1:0]), 
		.hit(VA48_CAM_hit) );
	
	  //
	 // include instantiations 
	//---------------------------
%000032	uwire [32-1:0] ras_key_int;
%000001	uwire ras_in_addr_val_int;
%000048	uwire [48-1:0] ras_in_addr_int;
%000001	uwire ras_rd_int;
%000000	uwire ras_out_addr_val_int;
%000024	uwire [48-1:0] ras_out_addr_int;
%000002	uwire ras_locked_int;
%000001	uwire ras_write_active_int;
%000003	uwire ras_empty_int;
%000001	uwire ras_full_int ;
	RAS #( 16, 48, 32, 32'h00000000 ) RAS16X48_K32( 
		clk, res_n, lock, unlock, ras_key_int[32-1:0], ras_in_addr_val_int, ras_in_addr_int[48-1:0], ras_rd_int, // inputs
		ras_out_addr_val_int, ras_out_addr_int[48-1:0], ras_locked_int, ras_write_active_int, ras_empty_int, ras_full_int  ); // outputs
	
	   //
	  // user-defined SystemVerilog support code 
	 // (derived from <support> section) 
	//----------------------------------
%000033	logic [VA48_CAM_ENTRY_WIDTH-1:0] data_from_tlb;
	assign ras_key_int = 32'h00000000;
	assign ras_in_addr_val_int = 1'b0;
	assign ras_in_addr_int = '0;
	assign ras_rd_int = 1'b0;
	
	   //
	  // implicit continuous assignments 
	 // (derived from <expressions> section) 
	//----------------------------------
	assign locked = IS_LOCKED;
%000006	uwire DO_IDLE; assign DO_IDLE = !res_n || (IS_LOCKED && !unlock) || (!IS_LOCKED && !virt_addr_in_vld);
%000000	uwire DO_LOCK; assign DO_LOCK = lock & !unlock ;
%000002	uwire DO_UNLOCK; assign DO_UNLOCK = !lock &  unlock & IS_KEY_MATCH;
%000002	uwire IS_KEY_MATCH; assign IS_KEY_MATCH = (KEY==key);
%000003	uwire IS_LOCKED; assign IS_LOCKED = (STATE==LOCKED);
%000003	uwire IS_TLB_HIT; assign IS_TLB_HIT = (res_n && virt_addr_in_vld && VA48_CAM_hit);
%000008	uwire NEXT_LEVEL; assign NEXT_LEVEL = (res_n && virt_addr_in_vld && data_from_memory_vld && !VA48_CAM_hit);
%000005	uwire START_TWE; assign START_TWE = (res_n && virt_addr_in_vld);
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001	  STATE = LOCKED;
%000001	  VA48_CAM_wr = 1'b0;
%000001	  VA48_CAM_rd = 1'b0;
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	end
	
	  //
	 // state transfer
	//---------------------------
 000200	always_ff @( posedge clk ) begin
 000194	  if( res_n )
%000003	  verilator_coverage: (next point on previous line)

 000097	    STATE <= NEXT_STATE;
	  else
%000003	    STATE <= LOCKED;
	
	  // $finish (Verilator)
%000002	  if( lock==1'b1 && unlock==1'b1 && res_n==1'b0 ) begin
 000099	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
	// cover property ( @(posedge clk) rd_q0==1'b1 && rd_q1==1'b1 && res_n==1'b0 );
	
 000414	always_comb begin
	
	    //
	   // pre-case (default) assignments 
	  //----------------------------------
 000207	  data_from_tlb = ZERO_CAM_ENTRY;
 000207	  data_to_memory = ZERO_DATA_TO_MEMORY;
 000207	  data_to_memory_vld = 1'b0;
 000207	  phys_addr_out = ZERO_PHYS_ADDR_OUT;
 000207	  phys_addr_out_vld = 1'b0;
 000207	  twe_active = 1'b0;
 000207	  NOP_VA48_CAM();
	
 000207	  unique case ( STATE )
 000022	  LOCKED : begin
 000020		if ( !DO_UNLOCK ) begin
%000001		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = LOCKED;
		end
%000002		if ( DO_UNLOCK ) begin
 000010		verilator_coverage: (next point on previous line)

%000001		  NEXT_STATE = IDLE;
		end
	  end // LOCKED
 000152	  IDLE : begin
 000148		if ( DO_IDLE ) begin
%000002		verilator_coverage: (next point on previous line)

 000074		  NEXT_STATE = IDLE;
		end
%000000		if ( DO_LOCK ) begin
 000076		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = LOCKED;
		end
%000004		if ( START_TWE ) begin
 000074		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = PTE0;
%000002		  twe_active=1'b1;
		end
	  end // IDLE
 000050	  PTE0 : begin
 000048		if ( !NEXT_LEVEL ) begin
%000001		verilator_coverage: (next point on previous line)

 000024		  NEXT_STATE = PTE0;
 000024		  data_from_tlb=POP_VA48_CAM(1'b1,{virt_addr_in[VA48_ADDR_WIDTH-1:VA48_INDEX_WIDTH],{VA48_PTE_PAGE_BASE_ADDR_WIDTH{1'b0}}});
 000024		  twe_active=1'b1;
 000024		  data_to_memory={pte_root_addr[PA48_ADDR_WIDTH-1:VA48_PTE_OFFSET_SIZE],virt_addr_in[VA48_PTE_LEVEL0_HIGH:VA48_PTE_LEVEL0_LOW]};
 000024		  data_to_memory_vld=1'b1;
		end
%000004		if ( IS_TLB_HIT ) begin
 000023		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = DONE;
%000002		  twe_active=1'b1;
%000002		  phys_addr_out={data_from_tlb[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_INDEX_WIDTH-1:0]};
%000002		  phys_addr_out_vld=1'b1;
		end
%000000		if ( DO_IDLE ) begin
 000025		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
%000002		if ( NEXT_LEVEL ) begin
 000024		verilator_coverage: (next point on previous line)

%000001		  NEXT_STATE = PTE1;
%000001		  twe_active=1'b1;
%000001		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL1_HIGH:VA48_PTE_LEVEL1_LOW],3'b000};
		end
	  end // PTE0
 000048	  PTE1 : begin
 000044		if ( !NEXT_LEVEL ) begin
%000002		verilator_coverage: (next point on previous line)

 000022		  NEXT_STATE = PTE1;
 000022		  twe_active=1'b1;
 000022		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL1_HIGH:VA48_PTE_LEVEL1_LOW],3'b000};
 000022		  data_to_memory_vld=1'b1;
		end
%000004		if ( NEXT_LEVEL ) begin
 000022		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = PTE2;
%000002		  twe_active=1'b1;
%000002		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL2_HIGH:VA48_PTE_LEVEL2_LOW],3'b000};
		end
%000000		if ( DO_IDLE ) begin
 000024		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
	  end // PTE1
 000048	  PTE2 : begin
 000044		if ( !NEXT_LEVEL ) begin
%000002		verilator_coverage: (next point on previous line)

 000022		  NEXT_STATE = PTE2;
 000022		  twe_active=1'b1;
 000022		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL2_HIGH:VA48_PTE_LEVEL2_LOW],3'b000};
 000022		  data_to_memory_vld=1'b1;
		end
%000004		if ( NEXT_LEVEL ) begin
 000022		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = PTE3;
%000002		  twe_active=1'b1;
%000002		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL3_HIGH:VA48_PTE_LEVEL3_LOW],3'b000};
		end
%000000		if ( DO_IDLE ) begin
 000024		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
	  end // PTE2
 000048	  PTE3 : begin
 000044		if ( !NEXT_LEVEL ) begin
%000002		verilator_coverage: (next point on previous line)

 000022		  NEXT_STATE = PTE3;
 000022		  twe_active=1'b1;
 000022		  data_to_memory={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_PTE_LEVEL3_HIGH:VA48_PTE_LEVEL3_LOW],3'b000};
 000022		  data_to_memory_vld=1'b1;
		end
%000004		if ( NEXT_LEVEL ) begin
 000022		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = WRITE_TLB;
%000002		  twe_active=1'b1;
		end
%000000		if ( DO_IDLE ) begin
 000024		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
	  end // PTE3
%000004	  WRITE_TLB : begin
%000004		if ( !DO_IDLE ) begin
%000000		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = DONE;
%000002		  PUSH_VA48_CAM(1'b1,{virt_addr_in[VA48_ADDR_WIDTH-1:VA48_INDEX_WIDTH],data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0]});
%000002		  twe_active=1'b1;
%000002		  phys_addr_out={data_from_memory[VA48_PTE_PAGE_BASE_ADDR_WIDTH-1:0],virt_addr_in[VA48_INDEX_WIDTH-1:0]};
%000002		  phys_addr_out_vld=1'b1;
		end
%000000		if ( DO_IDLE ) begin
%000002		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = IDLE;
		end
	  end // WRITE_TLB
 000042	  DONE : begin
 000038		if ( !DO_IDLE ) begin
%000002		verilator_coverage: (next point on previous line)

 000019		  NEXT_STATE = DONE;
		end
%000004		if ( DO_IDLE ) begin
 000019		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = IDLE;
		end
	  end // DONE
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
%000004	logic VA48_CAM_rd;
%000103	logic [VA48_CAM_ENTRY_WIDTH-1:0] VA48_CAM_rd_data;
	
 000048	function automatic [VA48_CAM_ENTRY_WIDTH-1:0] POP_VA48_CAM( read, [VA48_CAM_ENTRY_WIDTH-1:0] read_data );
 000024	   VA48_CAM_rd = read;
 000024	   VA48_CAM_wr_data = read_data;
 000024	   return VA48_CAM_rd_data;
	endfunction
	
%000003	logic VA48_CAM_wr;
%000156	logic [VA48_CAM_ENTRY_WIDTH-1:0] VA48_CAM_wr_data;
	
%000004	function automatic void PUSH_VA48_CAM( write, [VA48_CAM_ENTRY_WIDTH-1:0] write_data );
%000002	   VA48_CAM_wr = write;
%000002	   VA48_CAM_wr_data = write_data;
	endfunction
	
 000414	function automatic void NOP_VA48_CAM();
 000207	   VA48_CAM_rd = 1'b0;
 000207	   VA48_CAM_wr = 1'b0;
 000207	   VA48_CAM_wr_data = '0;
 000207	   VA48_CAM_rd_data = '0;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module CAM ( clk, res_n, wr, wr_data, rd, rd_data, hit );
	
	parameter DATA_WIDTH = 32;
	parameter NUM_ENTRIES = 16;
	parameter TAG_WIDTH = 8;
	
 000201	input  logic clk, res_n, rd, wr;
%000003	verilator_coverage: (next point on previous line)

%000004	verilator_coverage: (next point on previous line)

%000003	verilator_coverage: (next point on previous line)

%000156	input  logic [DATA_WIDTH-1:0] wr_data;
%000103	output logic [DATA_WIDTH-1:0] rd_data;
%000004	output logic hit;
	    
	localparam integer ADDR_WIDTH = $clog2(NUM_ENTRIES);
	localparam integer ENTRY_WIDTH = DATA_WIDTH - TAG_WIDTH;
	
	localparam [ADDR_WIDTH-1:0] ZERO_ADDR = {ADDR_WIDTH{1'b0}};
	localparam [DATA_WIDTH-1:0] ZERO_DATA = {DATA_WIDTH{1'b0}};
	
	logic [DATA_WIDTH-1:0] MEMORY [NUM_ENTRIES-1:0];
%000004	logic [ADDR_WIDTH-1:0] HEAD, HEAD_PLUS_1; 
%000007	verilator_coverage: (next point on previous line)

%000010	logic [NUM_ENTRIES-1:0] compare;
	
%000002	initial begin
%000001	    for ( int i = 0; i < NUM_ENTRIES; i = i + 1 ) begin
 000032	    verilator_coverage: (next point on previous line)

 000016	        MEMORY[ i ] = ZERO_DATA;
	    end
%000001	    HEAD = ZERO_ADDR;
	end
	
	// content addressable compare function
	assign compare = ( rd && !wr && res_n ) ? compare_fcn() : '0;
	
	// in-cycle read access
	assign rd_data = ( rd && !wr && res_n ) ? read_fcn() : ZERO_DATA;
	
	// append entries (wrap)
	assign HEAD_PLUS_1 = HEAD + 1'b1;
	
 000200	always @ ( posedge clk ) begin
	
 000194	  if( res_n ) begin
%000003	  verilator_coverage: (next point on previous line)

%000002	    if( wr && !rd ) begin // WRITE ACCESS
 000096	    verilator_coverage: (next point on previous line)

%000001	      MEMORY[HEAD] <= wr_data;
%000001	      HEAD <= HEAD_PLUS_1;
	    end
%000003	  end else begin
%000003	      HEAD <= clear_fcn();
	  end
	end
	
 000414	function automatic [NUM_ENTRIES-1:0] compare_fcn();
 006624	  for( int i=0; i<NUM_ENTRIES; i++ ) begin
 000207	  verilator_coverage: (next point on previous line)

 003312	    compare_fcn[i] = ( MEMORY[i][DATA_WIDTH-1:ENTRY_WIDTH] == wr_data[DATA_WIDTH-1:ENTRY_WIDTH] );
	  end
	endfunction
	
 000414	function automatic [DATA_WIDTH-1:0] read_fcn();
 000207	  read_fcn = ZERO_DATA;
 000207	  hit = 1'b0;
 006528	  for( int i=0; i<NUM_ENTRIES; i++ )
 000207	  verilator_coverage: (next point on previous line)

%000000	    if( 1'b1 == compare[i] ) begin
 003264	    verilator_coverage: (next point on previous line)

%000000	      read_fcn = MEMORY[i];
%000000	      hit = rd && !wr && compare[i];
%000000	      break;	
	    end
	endfunction
	
%000006	function automatic [ADDR_WIDTH-1:0] clear_fcn();
 000096	  for( int i=0; i<NUM_ENTRIES; i++ )
%000003	  verilator_coverage: (next point on previous line)

 000048	      MEMORY[ i ] <= ZERO_DATA;
%000003	  clear_fcn = ZERO_ADDR;
	endfunction
	
	endmodule
	
